"use strict";

function _createForOfIteratorHelper(o, allowArrayLike) { var it = typeof Symbol !== "undefined" && o[Symbol.iterator] || o["@@iterator"]; if (!it) { if (Array.isArray(o) || (it = _unsupportedIterableToArray(o)) || allowArrayLike && o && typeof o.length === "number") { if (it) o = it; var i = 0; var F = function F() {}; return { s: F, n: function n() { if (i >= o.length) return { done: true }; return { done: false, value: o[i++] }; }, e: function e(_e) { throw _e; }, f: F }; } throw new TypeError("Invalid attempt to iterate non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); } var normalCompletion = true, didErr = false, err; return { s: function s() { it = it.call(o); }, n: function n() { var step = it.next(); normalCompletion = step.done; return step; }, e: function e(_e2) { didErr = true; err = _e2; }, f: function f() { try { if (!normalCompletion && it.return != null) it.return(); } finally { if (didErr) throw err; } } }; }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

;

(function () {
  if (window.WebViewJavascriptBridge) {
    // 如果已经初始化过，直接return
    return;
  } // JS本地注册的事件处理程序


  var messageHandlers = {}; //  JS调用原生结果处理回调函数

  var responseCallbacks = {};
  var uniqueId = 1; // 具体的JS向原生发送消息逻辑

  function _doSend(message, responseCallback) {
    if (responseCallback) {
      var callbackId = "cb_" + uniqueId++ + "_" + new Date().getTime();
      responseCallbacks[callbackId] = responseCallback;
      message["callbackId"] = callbackId;
    }

    var msg = JSON.stringify(message || {}); // 原生注入的JSBridge对象

    if (window.WVJBInterface) {
      // JS向原生发送消息
      _logObj("H5-->Native ".concat(message["handlerName"]), JSON.parse(msg));

      WVJBInterface.notice(msg);
    } else {
      // 出现错误，打印出日志
      _log("WebViewJavascriptBridge: WARNING: \u53D1\u9001\u7ED9\u539F\u751F\u65B9\u6D88\u606F\u5931\u8D25\uFF0C\u6CA1\u6709\u6CE8\u5165WVJBInterface\u5BF9\u8C61\u3002".concat(message));
    }
  }

  var bridge = {
    // 注册处理器
    registerHandler: function registerHandler(handlerName, handler) {
      messageHandlers[handlerName] = handler;
    },
    // JS调用原生函数
    callHandler: function callHandler(handlerName, data, responseCallback) {
      _log("H5\u53D1\u9001\u6D88\u606F: ".concat(handlerName, " ").concat(JSON.stringify(data))); //      if (arguments.length === 2 && typeof data === "function") {
      //        responseCallback = data
      //        data = null
      //      }


      if (data) {
        data = jsBridgeParse(data);
      }

      _doSend({
        handlerName: handlerName,
        data: data
      }, responseCallback);
    },
    // 原生调用JS
    _handleMessageFromJava: function _handleMessageFromJava(json) {
      _dispatchMessageFromJava(json);
    },
    // 检查原生是否提供指定的处理器支持
    hasNativeMethod: function hasNativeMethod(name, responseCallback) {
      this.callHandler("_hasNativeMethod", name, responseCallback);
    }
  };

  function jsBridgeParse(obj) {
    return JSON.parse(JSON.stringify(obj).replace('"', '"'));
  } // 检查JS是否提供指定的处理器支持


  bridge.registerHandler("_hasJavascriptMethod", function (data, responseCallback) {
    responseCallback(!!messageHandlers[data]);
  }); //   处理并且分发来自原生的消息，包括双向通讯的消息

  function _dispatchMessageFromJava(messageJson) {
    _log("\u6536\u5230\u6765\u81EANative\u7684\u6D88\u606F ".concat(messageJson));

    if (!messageJson) {
      return;
    }

    var message = JSON.parse(messageJson);

    _logObj("Native-->H5", message);

    var responseCallback = null;

    if (message.responseId) {
      // 消息是JS调用原生之后的发来响应
      var _responseCallback = responseCallbacks[message.responseId];

      if (!_responseCallback) {
        return;
      }

      _responseCallback(message);

      delete responseCallbacks[message.responseId];
    } else {
      if (message.callbackId) {
        // 消息是原生调用JS发起的消息
        // 这里发送响应
        var callbackResponseId = message.callbackId;

        responseCallback = function responseCallback(responseData) {
          _doSend({
            handlerName: message.handlerName,
            responseId: callbackResponseId,
            responseData: responseData
          });
        };
      }

      var handler = messageHandlers[message.handlerName];

      if (!handler) {
        console.log("WebViewJavascriptBridge: WARNING: 没有消息处理器处理该消息", message);
      } else {
        handler(message.data, responseCallback);
      }
    }
  }

  function _log(message) {
    console.log("jssdk:", message);
  }

  function _logObj(tag, obj) {
    console.info("jssdk: ".concat(tag), obj);
  } // 因为通过原生注入此段初始化代码无法保证在 setupWebViewJavascriptBridge 之前执行，
  // 所以在这种情况下，WVJBCallbacks 中保存 setupWebViewJavascriptBridge传入的callback


  var callbacks = window.WVJBCallbacks;
  delete window.WVJBCallbacks;

  if (callbacks) {
    var _iterator = _createForOfIteratorHelper(callbacks),
        _step;

    try {
      for (_iterator.s(); !(_step = _iterator.n()).done;) {
        var cb = _step.value;
        cb(bridge);
      }
    } catch (err) {
      _iterator.e(err);
    } finally {
      _iterator.f();
    }
  }

  window.WebViewJavascriptBridge = bridge;
  console.log("注入函数执行完毕！!");
})();